{-# LANGUAGE Haskell2010                 #-}

{-# OPTIONS_GHC -fno-warn-unused-imports #-}

module Data.Multibase.Types 
  ( module M
  , encodeToMulltibase
  , encodeTextToMulltibase
  , IsMultibase(..)
  , IsCodec(..)
  , MbAlgorithm(..)
  , MbPipeline(..)
  , CodecDocs(..)
  , TestVector(..)
  , Decoding(..)
  , dispatching
  ) where

import           Data.Multibase.Types.Codecs                as M
import           Data.Multibase.Types.Multibase             as M
import           Data.Multibase.Types.MultibaseLazy         as M
import           Data.Multibase.Types.MultibaseShort        as M
import           Data.Multibase.Types.MultibaseBytes        as M
import           Data.Multibase.Types.MultibaseBytesLazy    as M
import           Data.Multibase.Types.MultibaseBytesShort   as M
import           Data.Multibase.Types.Internal.Basic
import           Data.Multibase.Types.Internal.ByteString                        as M
import           Data.Multibase.Types.Internal.IsCodec
import           Data.Multibase.Types.Internal.IsMultibase
import           Data.Multibase.Types.Internal.MbDecodeFailure                   as M


-- | encode 'ByteString' to 'Multibase' using one of the respectable codecs (i.e., one that has
-- been properly standardised and at least aspires to round-trip reliably)
encodeToMulltibase :: ByteString -> Multibase
encodeToMulltibase = encodeBase64PadToMultibase

-- | encode 'Text' to 'Multibase' using one of the respectable codecs (i.e., one that has
-- been properly standardised and at least aspires to round-trip reliably)
encodeTextToMulltibase :: Text -> Multibase
encodeTextToMulltibase = encodeTextInBase64PadToMultibase
