{-# LANGUAGE Haskell2010                #-}
{-# LANGUAGE BangPatterns               #-}
{-# LANGUAGE BinaryLiterals             #-}
{-# LANGUAGE ConstraintKinds            #-}
{-# LANGUAGE CPP                        #-}
{-# LANGUAGE DefaultSignatures          #-}
{-# LANGUAGE DeriveAnyClass             #-}
{-# LANGUAGE DeriveFunctor              #-}
{-# LANGUAGE DeriveGeneric              #-}
{-# LANGUAGE DeriveLift                 #-}
{-# LANGUAGE DerivingStrategies         #-}
{-# LANGUAGE DerivingVia                #-}
{-# LANGUAGE ExistentialQuantification  #-}
{-# LANGUAGE FlexibleContexts           #-}
{-# LANGUAGE FunctionalDependencies     #-}
{-# LANGUAGE GADTs                      #-}
{-# LANGUAGE GeneralisedNewtypeDeriving #-}
{-# LANGUAGE InstanceSigs               #-}
{-# LANGUAGE LambdaCase                 #-}
{-# LANGUAGE MultiWayIf                 #-}
{-# LANGUAGE NumericUnderscores         #-}
{-# LANGUAGE OverloadedStrings          #-}
{-# LANGUAGE PackageImports             #-}
{-# LANGUAGE QuasiQuotes                #-}
{-# LANGUAGE RankNTypes                 #-}
{-# LANGUAGE RecordWildCards            #-}
{-# LANGUAGE ScopedTypeVariables        #-}
{-# LANGUAGE StandaloneDeriving         #-}
{-# LANGUAGE StrictData                 #-}
{-# LANGUAGE TemplateHaskell            #-}
{-# LANGUAGE TupleSections              #-}
{-# LANGUAGE TypeApplications           #-}
{-# LANGUAGE TypeFamilies               #-}

{-# LANGUAGE UndecidableInstances       #-}

{-# OPTIONS_GHC -fno-warn-unused-imports  #-}

module Data.Multibase.Types.Internal.Basic 
  ( module Data.Multibase.Types.Internal.Basic
  , module M
  ) where

import           Control.DeepSeq                    as M (NFData(..))
import           Data.ByteString                    as M (ByteString)
import           Data.String                        as M (IsString(..))
import           GHC.Generics                       as M (Generic(..))
import           Data.Text                          as M (Text)
import           Data.Text.Encoding.Error           as M (UnicodeException)
import           Data.Typeable                      as M (Typeable,Proxy(..))
import           Language.Haskell.TH.Syntax         as M (Lift)

import qualified Data.ByteString.Lazy               as LBS
import qualified Data.ByteString.Short              as SBS
import qualified Data.Text.Lazy                     as LT
import qualified Data.Text.Short                    as ST


----------------------------------------------------------------------------------------------------
-- Useful Synonyms
----------------------------------------------------------------------------------------------------

type ByteStringLazy  = LBS.ByteString
type ByteStringShort = SBS.ShortByteString
type TextLazy        = LT.Text
type TextShort       = ST.ShortText


----------------------------------------------------------------------------------------------------
-- MbPipeline
----------------------------------------------------------------------------------------------------

data MbPipeline
  = MP_Text
  | MP_TextLazy
  | MP_TextShort
  | MP_Byte
  | MP_ByteLazy
  | MP_ByteShort
  deriving stock (Bounded,Enum,Eq,Generic,Lift,Ord,Show)
  